#!/usr/bin/perl
# Versione 1.21 - 15/9/98
# Versione 1.22 - 19/11/98 - Aggiunto controllo anti-loop

$html{'bgcolor'} = "#FFFFFF";
$html{'copyright'} = "<HR><SMALL>The Form Processor (C) 1997 Vittorio Bertola</SMALL>";

$param{'separatore'} = '+';
$param{'definito'} = '1';
$param{'uguale'} = '=';
$param{'log'} = 0;

$userbase = '/utenti/';
#$cfg_validation = '(^/utenti/.+/|^/cgi-bin/formcfg/)';
#$data_validation = '(^/utenti/.+/|^/cgi-bin/data/)';
#$read_validation = '(^/utenti/.+/|^/www/|^/cgi-bin/data/)';
$html_user_dir = '(/HTML/|/public_html/)';
$tempdir = '/www/indice/temp/';      # Temp dir sul filesystem principale
$tempdir_utenti = '/utenti/temp/';   # Temp dir sul filesystem degli utenti (pagine che matchano $userbase) (puo' coincidere col precedente)
$logfile = '/util/data/formproc.log';

$mailprog = '/usr/sbin/sendmail -t'; # Comando per spedire una mail (letta dallo stdin)

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$mon++;
$subval{'data'} = "$mday/$mon/$year";
$subval{'ora'} = ($min < 10 ? "$hour:0$min" : "$hour:$min" );


sub log {

    open(OUTFILE, ">>$logfile") or &send-error('no-open-log');
    foreach $string (@_) {print(OUTFILE "$string "); }
    print(OUTFILE "\n");
    close(OUTFILE);

}


sub do_or_wait {

    $i = 0;
    while (!eval($_[0]) && ($i < $_[1]))
       {sleep 1;
        $i++;}
    &log($i);

}


sub get_tempnam {

    local ($tmpdir) = $_[0]; 

    $ids = 'aaa';
    $n = $tmpdir . $ids . ".tmp";
    while (-e $n) {
        $ids++;
        $n = $tmpdir . $ids . ".tmp";
        &send_error("no-tempnam") if ($ids eq 'zzz');
    }   
    return $n;

}


sub send_error {

    $ext_ = $_;
    local($_) = $_[0];

    &log("ERRORE - Cod. errore", $_, "\n") if ($param{'log'});

    $html{'title'} = "Errore di interazione con il server";
    $html{'mailinfo'} = "In caso di problemi con questo programma, contattate <A HREF=\"mailto:www-help\@studenti.to.it\">www-help\@studenti.to.it</A> ";
    $html{'mailinfo'} .= "includendo il contenuto di questa pagina e l'indirizzo della vostra form. Per favore, prima di scrivere cercate di ";
    $html{'mailinfo'} .= "risolvere il problema leggendo attentamente la documentazione riportata nelle pagine del <A HREF=\"/homepage\">servizio Home Page</A>. ";
    $html{'mailinfo'} .= "Ricordate infatti che questo sito &egrave; portato avanti da un gruppo di studenti su base volontaria nel proprio tempo libero: saremo ";
    $html{'mailinfo'} .= "lieti di aiutarvi, ma visto il numero degli utenti non sempre possiamo essere tempestivi. Scusateci e grazie per la collaborazione!";
    $html{'upperbanner'} = "<TABLE WIDTH=\"100%\" CELLSPACING=0 CELLPADDING=0>\n<TR><TD ALIGN=left>";
    $html{'upperbanner'} .= "<A HREF=\"/homepage/\"><IMG SRC=\"../img/y_home.jpg\" WIDTH=73 HEIGHT=50 BORDER=0></A>\n";
    $html{'upperbanner'} .= "<TD ALIGN=right>\n<A HREF=\"/homepage/\"><IMG SRC=\"../img/o_home.gif\" WIDTH=278 HEIGHT=25 BORDER=0></A>\n</TABLE>";


    SW: {
       
        /no-post-vars/      && do {
     
            $html{'body'} = "Errore durante la lettura delle variabili con il metodo POST";
            $html{'debug'} = "Input letto = $html{'args'}";
            last SW;
           };

        /no-get-vars/       && do {

            $html{'body'} = "Errore durante la lettura delle variabili con il metodo GET";
            $html{'debug'} = "QUERY_STRING = $ENV{'QUERY_STRING'}";
            last SW;
           };

        /undef-method/      && do {

            $html{'body'} = "Il metodo proposto dal server non &egrave; supportato da questo programma.";
            $html{'debug'} = "REQUEST_METHOD = $ENV{'REQUEST_METHOD'}";
            last SW;
           };

        /unread-method/     && do {
 
            $html{'body'} = "Impossibile leggere il metodo d'accesso della form dall'ambiente del server.";
            last SW;
           };

        /incorrect-ctype/   && do {
 
            $html{'body'} = "Questo programma pu&ograve; essere richiamato soltanto da una form.<P>";
            $html{'debug'} = "CONTENT_TYPE = $ENV{'CONTENT_TYPE'}";
            last SW;
           };

        /undef-ctype/       && do {
 
            $html{'body'} = "Impossibile leggere il tipo del contenuto dall'ambiente del server.";
            last SW;
           };

        /no-cfg-file/       && do {
 
            $html{'body'} = "Non &egrave; stato specificato nella form alcun file di configurazione. Utilizzare un campo INPUT di nome <TT>config</TT> ";
            $html{'body'} .= "per indicare il percorso per raggiungere il file di configurazione. Esempio:<P>";
            $html{'body'} .= "<TT>&lt;INPUT TYPE=\"hidden\" NAME=\"config\" VALUE=\"/utenti/s76786/HTML/cgi-bin/form.cfg\"&gt;</TT>";
            last SW;
           };

        /cfg-loop/          && do {
 
            $html{'body'} = "Nel file di configurazione <TT>$subval{'config'}</TT> hai inserito il file stesso come nuovo file di configurazione da eseguire,";
            $html{'body'} .= "come valore del parametro <TT><B>\$param{'config'}</B></TT>, mandando in loop il sistema.";
            last SW;
           };

        /inval-cfg-file/    && do {

            $html{'body'} = "Il percorso specificato per il file di configurazione non pu&ograve; essere accettato. ";
            $html{'body'} .= "Il file di configurazione deve trovarsi nella vostra home directory (corrispondente al percorso <TT><B>/utenti/</B>login<B>/</B></TT>) o in una sua sottodirectory. ";
            $html{'body'} .= "Esso non deve inoltre trovarsi nella zona visibile dal WWW (directory <TT>HTML</TT> e sue sottodirectory).";
            $html{'debug'} = "Percorso del file di configurazione: $subval{'config'}";
            last SW;
           };
            
        /nopen-cfg-file/    && do {
 
            $html{'body'} = "Impossibile aprire il file specificato nella form nel campo <TT>config</TT>. ";
            $html{'body'} .= "Controllate che esista e che il percorso sia corretto.";
            $html{'debug'} = "Percorso del file di configurazione: $subval{'config'}";
            last SW;
           };

        /inval-cfg-line/    && do {
 
            $html{'body'} = "E' stata trovata una linea non valida nel file di configurazione della form. ";
            $html{'body'} .= "Controllate che la sintassi del vostro file sia corretta. Attenzione a parentesi graffe, apici singoli, punto e virgola...";
            $html{'debug'} = "Riga non valida:<BR>&gt;$ext_";
            last SW;
           };

        /no-tmp-mail/       && do {

            $html{'body'} = "Impossibile generare un file temporaneo per poter spedire il messaggio di posta elettronica. ";
            $html{'body'} .= "Segnalate questo errore al webmaster.";
            $html{'debug'} = "File temporaneo: $tempn";
            last SW;
           }; 

        /no-tmp-ins/       && do {

            $html{'body'} = "Impossibile generare un file temporaneo per poter elaborare il file in cui inserire i dati. ";
            $html{'body'} .= "Segnalate questo errore al webmaster.";
            $html{'debug'} = "File temporaneo: $tempn";
            last SW;
           }; 


        /no-tempnam/       && do {

            $html{'body'} = "Impossibile generare un nome per il file temporaneo per poter spedire il messaggio di posta elettronica. ";
            $html{'body'} .= "Segnalate questo errore al webmaster.";
            $html{'debug'} = "Ultimo nome provato: $n";
            last SW;
           }; 

        /no-write-file/     && do {

            $html{'body'} = "Impossibile aprire il file in cui scrivere il contenuto della form. ";
            $html{'body'} .= "Controllate che il percorso sia corretto, e che il file esista e sia stato aperto in scrittura a tutti, oppure ";
            $html{'body'} .= "che appartenga all'utente <TT>nobody</TT>, oppure ";
            $html{'body'} .= "che debba essere creato in una directory aperta in scrittura a tutti. Utilizzate eventualmente il comando chmod ";
            $html{'body'} .= "di WsFtp per modificare i privilegi del file.";
            $html{'debug'} = "File in oggetto: $param{'file'}";
            last SW;
           }; 

        /no-append-file/    && do {

            $html{'body'} = "Impossibile aprire il file in cui scrivere il contenuto della form. ";
            $html{'body'} .= "Controllate che il percorso sia corretto, e che il file esista e sia stato aperto in scrittura a tutti, oppure ";
            $html{'body'} .= "che appartenga all'utente <TT>nobody</TT>, oppure ";
            $html{'body'} .= "che esso non esista e debba essere creato in una directory aperta in scrittura a tutti. Utilizzate eventualmente il comando chmod ";
            $html{'body'} .= "di WsFtp per modificare i privilegi del file.";
            $html{'debug'} = "File in oggetto: $param{'file'}";
            last SW;
           }; 

        /inval-action/      && do {

            $html{'body'} = "L'azione specificata nel file di configurazione non &egrave; tra quelle ammesse.";     
            $html{'debug'} = "Azione specificata: $param{'azione'}";
            last SW;
           };

        /no-action/      && do {

            $html{'body'} = "Nel file di configurazione non &egrave; stata specificata alcuna azione da compiere. Assegnate un valore ";     
            $html{'body'} .= "al parametro <TT>\$param{'azione'}</TT> per stabilire l'azione da eseguire.";
            last SW;
           };

        /no-file/      && do {

            $html{'body'} = "Nel file di configurazione non &egrave; stato specificato il file in cui scrivere il contenuto della form. Assegnate un valore ";     
            $html{'body'} .= "al parametro <TT>\$param{'file'}</TT> per indicare il file di destinazione.";
            last SW;
           };

        /inval-file/    && do {

            $html{'body'} = "Il percorso specificato per il file di destinazione non pu&ograve; essere accettato. ";
            $html{'body'} .= "Il file di destinazione deve trovarsi nella vostra home directory o in una sua sottodirectory. ";
            $html{'debug'} = "File specificato: $param{'file'}";
            last SW;
           };

        /no-tmpl-file/      && do {

            $html{'body'} = "Nel file di configurazione non &egrave; stato specificato lo schema in cui inserire il contenuto della form. Assegnate un valore ";     
            $html{'body'} .= "al parametro <TT>\$param{'schema'}</TT> per indicare il file di destinazione.";
            last SW;
           };

        /inval-tmpl-file/    && do {

            $html{'body'} = "Il percorso specificato per lo schema di elaborazione della form non pu&ograve; essere accettato. ";
            $html{'body'} .= "Il file di schema deve trovarsi nella vostra home directory o in una sua sottodirectory.";
            $html{'debug'} = "File di schema specificato: $param{'schema'}";
            last SW;
           };

        /nopen-tmpl-file/    && do {

            $html{'body'} = "Impossibile aprire lo schema di elaborazione della form. Controllate che il percorso sia corretto, che il file esista e ";
            $html{'body'} .= "che sia aperto in lettura a tutti.";
            $html{'debug'} = "File di schema specificato: $param{'schema'}";
            last SW;
           };

        /inval-out-file/    && do {

            $html{'body'} = "Il percorso specificato per l'output HTML della form non pu&ograve; essere accettato. ";
            $html{'body'} .= "Il file di output deve trovarsi nella vostra home directory o in una sua sottodirectory.";
            $html{'debug'} = "File di output specificato: $param{'output'}";
            last SW;
           };

        /nopen-out-file/    && do {

            $html{'body'} = "Impossibile aprire il file per l'output HTML della form. Controllate che il percorso sia corretto, che il file esista e ";
            $html{'body'} .= "che sia aperto in lettura a tutti.";
            $html{'debug'} = "File di output specificato: $param{'output'}";
            last SW;
           };

        /no-rename-file/      && do {

            $html{'body'} = "Impossibile rinominare il file temporaneo nel file definitivo. ";     
            $html{'body'} .= "Segnalate questo errore al webmaster.";
            last SW;
           };

        /no-open-log/        && do {

            $html{'body'} = "Impossibile aprire il log. Per favore, incazzatevi col webmaster.";     
            last SW;
           };

        /mail-float/         && do {

            $html{'body'} = "Non &egrave; ammessa la presenza contemporanea di variabili all'interno ";
            $html{'body'} .= "dei campi <TT><B>From:</B></TT> e <TT><B>To:</B></TT> di un messaggio di mail. Modificate lo schema.";
            last SW;
           };

        $html{'body'} = "Errore sconosciuto.<BR>Cavolo, siete riusciti a piantare il programma proprio bene!!";
        $html{'debug'} = "Codice di errore: $_";
           
    }
    &print_html;
    die ($html{'body'});
 
}


sub print_html {

    print("Content-type:text/html\n\n<HTML>\n<HEAD>\n");
    print("<TITLE>$html{'title'}</TITLE>\n") if (defined($html{'title'}));
    print("</HEAD><BODY");
    if (defined($html{'bgcolor'})) {
        print(" BGCOLOR=\"$html{'bgcolor'}\">\n");
    } elsif (defined($html{'background'})) {
        print(" BACKGROUND=\"$html{'background'}\">\n");
    } else {
        print(">\n");
    }
    print("$html{'upperbanner'}\n") if (defined($html{'upperbanner'}));
    print("<CENTER><H2>$html{'title'}</H2></CENTER><HR>\n") if (defined($html{'title'}));
    print("$html{'body'}\n") if (defined($html{'body'}));
    print("<P>Informazioni per il debug:<P>\n<TT>$html{'debug'}</TT>\n") if (defined($html{'debug'}));
    print("<P>$html{'mailinfo'}\n") if (defined($html{'mailinfo'}));
    print("$html{'copyright'}\n") if (defined($html{'copyright'}));
    print("</BODY></HTML>\n");

}


sub url_decode {

    local($_) = $_[0];
    local(@ll);
    tr/+/ / ;
    @ll = /%([0-9a-fA-F][0-9a-fA-F])/g ;
    foreach $l (@ll) {
        if ($l ne '25') {
            $v = chr(hex($l));
            s/%$l/$v/ ;
        }
    }
    s/%25/%/g ;
    return $_ ;

}


sub get_post_vars {

    if (defined ($ENV{'CONTENT_TYPE'})) {
        &send_error ("incorrect-ctype") if ("\L$ENV{'CONTENT_TYPE'}" ne "application/x-www-form-urlencoded");
    } else {
        &send_error ("undef-ctype");        
    }
    $cl = $ENV{'CONTENT_LENGTH'};
    if ($cl > 0) {
        read STDIN, $_, $cl;
        $subval{'args'} = $_;
        s/%0D%0A/%0A/g ;  # Conversione ASCII DOS -> Unix
        @ll = ( /([^&]+)/g );
        foreach (@ll) {
            /^(.+?)=(.*?)$/ ;
            $d1 = &url_decode($1);
            $d2 = &url_decode($2);
            if (defined($subval{$d1})) {
                $subval{$d1} .= $param{'separatore'};
                $subval{$d1} .= $d2;
            } else {     
                $subval{$d1} = $d2;
            }  
            $subval{"${d1}$param{'uguale'}$d2"} = $param{'definito'};
        }  
        return 1;   
    } else {
        return 0;
    }

}
           

sub get_get_vars {

    if (defined ($ENV{'QUERY_STRING'})) {
        $_ = $ENV{'QUERY_STRING'};
        $subval{'args'} = $_;
        s/%0D%0A/%0A/g ;  # Conversione ASCII DOS -> Unix
        @ll = ( /([^&]+)/g );
        foreach (@ll) {
            /^(.+?)=(.*?)$/ ;
            $d1 = &url_decode($1);
            $d2 = &url_decode($2);
            if (defined($subval{$d1})) {
                $subval{$d1} .= $param{'separatore'};
                $subval{$d1} .= $d2;
            } else {     
                $subval{$d1} = $d2;
            }  
            $subval{"${d1}$param{'uguale'}$d2"} = $param{'definito'};
        }
        return 1;       
    } else {
        return 0;
    }

}


sub read_form_args {

    if (defined ($ENV{'REQUEST_METHOD'})) {
        if ("\U$ENV{'REQUEST_METHOD'}" eq "POST") {
            &get_post_vars or &send_error("no-post-vars");
        } elsif ("\U$ENV{'REQUEST_METHOD'}" eq "GET") {
            &get_get_vars or &send_error("no-get-vars");
        } else {
            &send_error ("undef-method");
        }
    } else {
       &send_error ("unread-method");
    }

}
      

sub read_cgi_args {

    $subval{'cgi_ip'} = $ENV{'REMOTE_ADDR'};
    $subval{'cgi_host'} = $ENV{'REMOTE_HOST'};
    $subval{'cgi_browser'} = $ENV{'HTTP_USER_AGENT'};
    $subval{'cgi_referer'} = $ENV{'HTTP_REFERER'};

}


sub eval_cfg_file {

    if (defined($cfg_validation)) {
        &send_error("inval-cfg-file") if (($subval{'config'} !~ m!$cfg_validation! ) || ($subval{'config'} =~ m!$html_user_dir! )); 
    }
    open(CFGFILE, $subval{'config'}) or &send_error("nopen-cfg-file");
    while (<CFGFILE>) {
        if ( /^\s*\$param{'.+'}\s*=\s*'.*'\s*;\s*$/ ) {
            eval;
        } else {
            if (! /^\s*#|^\s*$/ ) {
                close(CFGFILE);
                &send_error("inval-cfg-line");
            } 
        }
    }
    close(CFGFILE);

}


sub parse_line {

    local(@ll);
    @ll = /%(.*?)%/g;
    foreach $item (@ll)
        {s/%$item%/$subval{"\L$item"}/;}
    print(OUTFILE);

}


sub parse_line_hd {

    local(@ll);
    local($sub) = $_[0];

    @ll = /%(.*?)%/g;
    if (scalar(@ll) > 0) {
        $sub++ if ((/from\s*:/i) || (/to\s*:/i)); 
        foreach $item (@ll)
            {s/%$item%/$subval{"\L$item"}/;}
        print(OUTFILE);
    } elsif (/^\s*$/) {
        $sub = 0;
        if ($tba) {
            $_ = "X-CGI-From: Formproc on www.poli.studenti.to.it\nX-Complaints-To: webmaster\@studenti.to.it\nX-Form-Config: " . $subval{'config'} ."\n" . $_;
            $tba = 0;
        }
    }
    return $sub;

}


sub parse_template {

    local($sub) = 0;
    local($tba) = 1;
    $body = '';
    &send_error("no-tmpl-file") if (!defined($param{'schema'}));
    if (defined($read_validation)) {
        &send_error("inval-tmpl-file") if ($param{'schema'} !~ m!$read_validation! );
    }
    open(INFILE, $param{'schema'}) or &send_error("nopen-tmpl-file");
    if ($param{'azione'} =~ /spedisci/) {
        while (<INFILE>) {
            $sub = &parse_line_hd($sub);
            &send_error("mail-float") if ($sub >= 2);
            $body .= $_;
        }
    } else {
        while (<INFILE>) {
            &parse_line;
            $body .= $_;
        }
    }
    close(INFILE);

}


sub parse_output {

    if (defined($read_validation)) {
        &send_error("inval-out-file") if ($param{'output'} !~ m!$read_validation! );
    }
    open(INFILE, $param{'output'}) or &send_error("nopen-out-file");
    print("Content-type:text/html\n\n");
    while (<INFILE>) {
        &parse_line;
        print;
    }
    close(INFILE);

}
    


sub do_it {

   &send_error("no-action") if (!defined ($param{'azione'}));
   for ($param{'azione'}) { SWC: {
   
      /spedisci/      && do {

          $tempn = &get_tempnam($tempdir);         
          &log("File temporaneo per spedisci:", $tempn, "\n") if ($param{'log'});
          open (TMPFILE, ">$tempn") or &send_error("no-tmp-mail");
          print(TMPFILE $body);
          close(TMPFILE);
          $mailout = qx!$mailprog < $tempn! ;
          unlink($tempn);
          &log("Spedito e cancellato file temporaneo\n", "Output sendmail", $mailout, "\n") if ($param{'log'});
          last SWC;
         };

      /scrivi/        && do {

          &send_error("no-file") if (! defined($param{'file'}));
          if (defined($data_validation)) {
              &send_error("inval-file") if ($param{'file'} !~ m!$data_validation! ); 
          }
          open (DSTFILE, ">$param{'file'}") or &send_error("no-write-file");
          print(DSTFILE $body);
          close(DSTFILE);         
          &log("Scritto corpo a", $param{'file'}, "\n") if ($param{'log'});
          last SWC;
         };

      /appendi/       && do {

          &send_error("no-file") if (! defined($param{'file'}));
          if (defined($data_validation)) {
              &send_error("inval-file") if ($param{'file'} !~ m!$data_validation! ); 
          }
          open (DSTFILE, ">>$param{'file'}") or &send_error("no-append-file");
          print(DSTFILE $body);
          close(DSTFILE);         
          &log("Appeso corpo a", $param{'file'}, "\n") if ($param{'log'});
          last SWC;
         };

      /inserisci/       && do {

          &send_error("no-file") if (! defined($param{'file'}));
          if (defined($data_validation)) {
              &send_error("inval-file") if ($param{'file'} !~ m!$data_validation! ); 
          }
          if ($param{'file'} =~ m!$userbase!) {
              $tempn = &get_tempnam($tempdir_utenti);
          } else {         
              $tempn = &get_tempnam($tempdir);
          }   
          &log("File temporaneo per inserisci:", $tempn, "\n") if ($param{'log'});
          open (TMPFILE, ">$tempn") or &send_error("no-tmp-ins");
          open (SRCFILE, "$param{'file'}") or &send_error("no-append-file");
          $_ = <SRCFILE>;
          while (defined($_) && (! /$param{'marcatore'}/ )) {
              print(TMPFILE);
              $_ = <SRCFILE>;
          }

          print(TMPFILE $body);
          print(TMPFILE "$param{'marcatore'}\n") if ($param{'posizione'} ne 'prima');      
          print(TMPFILE) while(<SRCFILE>);
          close(TMPFILE);
          close(SRCFILE);
          system "mv $tempn $param{'file'}";
          &log("Spostato in", $param{'file'}, "\n") if ($param{'log'});
          if (defined ($param{'login'})) {
              system "chown $param{'login'} $param{'file'}";
              &log("Cambiato owner di ", $param{'file'}, " a ", $param{'login'}, "\n") if ($param{'log'});
          }
          last SWC;
         };


      &send_error("inval-action");

     }         
   }

}

$startdate = localtime();
&log($startdate, "Inizio lettura argomenti form...") if ($param{'log'});
&read_form_args;
&read_cgi_args;
&send_error("no-cfg-file") if (!defined($subval{'config'}));
while (defined($subval{'config'})) {
    &eval_cfg_file;
# $param{'log'} = 1;  # Forzo il log!
    &log($startdate, "Letta configurazione", $subval{'config'}, "esamino schema...\n") if ($param{'log'});
    &parse_template;
    &do_it;
    if (defined($param{'config'})) {
        &send_error('cfg-loop') if ($param{'config'} eq $subval{'config'});
        $subval{'config'} = $param{'config'};
        undef $param{'config'};
    } else {
        undef $subval{'config'};
    }
}
if (defined($param{'output'})) {
    &log("Esamino schema output", $param{'output'}, "\n") if ($param{'log'});
    &parse_output;
} else {
    &log("Spedisco output standard...\n") if ($param{'log'});
    $html{'title'} = "Il modulo &egrave; stato processato.";
    $html{'body'} = "I dati che avete inserito sono stati elaborati secondo le indicazioni fornite dall'autore del modulo. ";
    $html{'body'} .= "Grazie per avere contribuito alle nostre pagine!";
    &print_html;
}
&log("Terminato\n\n") if ($param{'log'});
